/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables.records;


import de.ship.clip.db.tables.TMenuitem;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TMenuitemRecord extends UpdatableRecordImpl<TMenuitemRecord> implements Record8<Integer, String, Integer, Integer, String, String, Integer, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>config.t_menuitem.pk</code>.
     */
    public void setPk(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>config.t_menuitem.pk</code>.
     */
    public Integer getPk() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>config.t_menuitem.url</code>.
     */
    public void setUrl(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>config.t_menuitem.url</code>.
     */
    public String getUrl() {
        return (String) get(1);
    }

    /**
     * Setter for <code>config.t_menuitem.fk_label</code>.
     */
    public void setFkLabel(Integer value) {
        set(2, value);
    }

    /**
     * Getter for <code>config.t_menuitem.fk_label</code>.
     */
    public Integer getFkLabel() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>config.t_menuitem.fk_description</code>.
     */
    public void setFkDescription(Integer value) {
        set(3, value);
    }

    /**
     * Getter for <code>config.t_menuitem.fk_description</code>.
     */
    public Integer getFkDescription() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>config.t_menuitem.app_id</code>.
     */
    public void setAppId(String value) {
        set(4, value);
    }

    /**
     * Getter for <code>config.t_menuitem.app_id</code>.
     */
    public String getAppId() {
        return (String) get(4);
    }

    /**
     * Setter for <code>config.t_menuitem.icon_url</code>.
     */
    public void setIconUrl(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>config.t_menuitem.icon_url</code>.
     */
    public String getIconUrl() {
        return (String) get(5);
    }

    /**
     * Setter for <code>config.t_menuitem.order_nr</code>.
     */
    public void setOrderNr(Integer value) {
        set(6, value);
    }

    /**
     * Getter for <code>config.t_menuitem.order_nr</code>.
     */
    public Integer getOrderNr() {
        return (Integer) get(6);
    }

    /**
     * Setter for <code>config.t_menuitem.keycloak_role</code>.
     */
    public void setKeycloakRole(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>config.t_menuitem.keycloak_role</code>.
     */
    public String getKeycloakRole() {
        return (String) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row8<Integer, String, Integer, Integer, String, String, Integer, String> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    @Override
    public Row8<Integer, String, Integer, Integer, String, String, Integer, String> valuesRow() {
        return (Row8) super.valuesRow();
    }

    @Override
    public Field<Integer> field1() {
        return TMenuitem.T_MENUITEM.PK;
    }

    @Override
    public Field<String> field2() {
        return TMenuitem.T_MENUITEM.URL;
    }

    @Override
    public Field<Integer> field3() {
        return TMenuitem.T_MENUITEM.FK_LABEL;
    }

    @Override
    public Field<Integer> field4() {
        return TMenuitem.T_MENUITEM.FK_DESCRIPTION;
    }

    @Override
    public Field<String> field5() {
        return TMenuitem.T_MENUITEM.APP_ID;
    }

    @Override
    public Field<String> field6() {
        return TMenuitem.T_MENUITEM.ICON_URL;
    }

    @Override
    public Field<Integer> field7() {
        return TMenuitem.T_MENUITEM.ORDER_NR;
    }

    @Override
    public Field<String> field8() {
        return TMenuitem.T_MENUITEM.KEYCLOAK_ROLE;
    }

    @Override
    public Integer component1() {
        return getPk();
    }

    @Override
    public String component2() {
        return getUrl();
    }

    @Override
    public Integer component3() {
        return getFkLabel();
    }

    @Override
    public Integer component4() {
        return getFkDescription();
    }

    @Override
    public String component5() {
        return getAppId();
    }

    @Override
    public String component6() {
        return getIconUrl();
    }

    @Override
    public Integer component7() {
        return getOrderNr();
    }

    @Override
    public String component8() {
        return getKeycloakRole();
    }

    @Override
    public Integer value1() {
        return getPk();
    }

    @Override
    public String value2() {
        return getUrl();
    }

    @Override
    public Integer value3() {
        return getFkLabel();
    }

    @Override
    public Integer value4() {
        return getFkDescription();
    }

    @Override
    public String value5() {
        return getAppId();
    }

    @Override
    public String value6() {
        return getIconUrl();
    }

    @Override
    public Integer value7() {
        return getOrderNr();
    }

    @Override
    public String value8() {
        return getKeycloakRole();
    }

    @Override
    public TMenuitemRecord value1(Integer value) {
        setPk(value);
        return this;
    }

    @Override
    public TMenuitemRecord value2(String value) {
        setUrl(value);
        return this;
    }

    @Override
    public TMenuitemRecord value3(Integer value) {
        setFkLabel(value);
        return this;
    }

    @Override
    public TMenuitemRecord value4(Integer value) {
        setFkDescription(value);
        return this;
    }

    @Override
    public TMenuitemRecord value5(String value) {
        setAppId(value);
        return this;
    }

    @Override
    public TMenuitemRecord value6(String value) {
        setIconUrl(value);
        return this;
    }

    @Override
    public TMenuitemRecord value7(Integer value) {
        setOrderNr(value);
        return this;
    }

    @Override
    public TMenuitemRecord value8(String value) {
        setKeycloakRole(value);
        return this;
    }

    @Override
    public TMenuitemRecord values(Integer value1, String value2, Integer value3, Integer value4, String value5, String value6, Integer value7, String value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TMenuitemRecord
     */
    public TMenuitemRecord() {
        super(TMenuitem.T_MENUITEM);
    }

    /**
     * Create a detached, initialised TMenuitemRecord
     */
    public TMenuitemRecord(Integer pk, String url, Integer fkLabel, Integer fkDescription, String appId, String iconUrl, Integer orderNr, String keycloakRole) {
        super(TMenuitem.T_MENUITEM);

        setPk(pk);
        setUrl(url);
        setFkLabel(fkLabel);
        setFkDescription(fkDescription);
        setAppId(appId);
        setIconUrl(iconUrl);
        setOrderNr(orderNr);
        setKeycloakRole(keycloakRole);
        resetChangedOnNotNull();
    }
}
